<!DOCTYPE html>
<html>
<head>
    <title>QR & JAN Code Reader with Multiple Modes and Web Audio API</title>
    <script src="https://unpkg.com/@zxing/library@latest"></script>
</head>
<body>
    <H1>POKA YOKE WEB DEMO</H1>
    <video id="video" width="800" height="400" style="border: 1px solid gray"></video>
    <BR>
    <button id="btn">Start Camera</button>
    <button id="clearBtn">Clear Master Data</button>
    <select id="modeSelect">
        <option value="oneToOne">1 on 1 Mode</option>
        <option value="oneToN">1 on N Mode</option>
        <option value="treasureHunt">Treasure Hunt Mode</option>
        <option value="partialMatch">Partial Match Mode</option>
    </select>
    <input type="text" id="partialMatchInput" placeholder="Enter data for partial match" style="display: none;">
    <p id="result"></p>

    <script>
        let selectedDeviceId;
        const codeReader = new ZXing.BrowserMultiFormatReader();
        const video = document.getElementById('video');
        let masterData = null;
        const modeSelect = document.getElementById('modeSelect');
        const partialMatchInput = document.getElementById('partialMatchInput');
        let audioContext = new (window.AudioContext || window.webkitAudioContext)();

        modeSelect.addEventListener('change', function() {
            partialMatchInput.style.display = this.value === 'partialMatch' ? '' : 'none';
        });

        document.getElementById('btn').addEventListener('click', () => {
            codeReader.listVideoInputDevices()
                .then((videoInputDevices) => {
                    selectedDeviceId = videoInputDevices[0].deviceId;
                    codeReader.decodeFromVideoDevice(selectedDeviceId, 'video', (result, err) => {
                        if (result) {
                            onScanSuccess(result.text);
                        }
                        if (err && !(err instanceof ZXing.NotFoundException)) {
                            console.error(err);
                            document.getElementById('result').textContent = err;
                        }
                    });
                })
                .catch((err) => {
                    console.error(err);
                });
        });

        document.getElementById('clearBtn').addEventListener('click', () => {
            masterData = null;
            document.getElementById('result').textContent = 'Master data cleared.';
        });

        function beep(duration, frequency, volume) {
            let oscillator = audioContext.createOscillator();
            let gainNode = audioContext.createGain();

            oscillator.connect(gainNode);
            gainNode.connect(audioContext.destination);

            gainNode.gain.value = volume;
            oscillator.frequency.value = frequency;
            oscillator.type = "square";

            oscillator.start(audioContext.currentTime);
            oscillator.stop(audioContext.currentTime + duration * 0.001);
        }

        function onScanSuccess(scannedText) {
            beep(200, 520, 1); // Play beep sound (200 ms duration, 520 Hz frequency)

            if (modeSelect.value === 'partialMatch') {
                const partialData = partialMatchInput.value;
                if (scannedText.includes(partialData)) {
                    displayResult(scannedText, "⭕️");
                } else {
                    displayResult("Un-matched", "");
                }
                return;
            }

            if (masterData === null) {
                masterData = scannedText;
                displayResult(scannedText, "⭕️");
            } else {
                switch (modeSelect.value) {
                    case "oneToOne":
                        displayResult(scannedText, scannedText === masterData ? "⭕️" : "❌");
                        break;
                    case "oneToN":
                        if (scannedText === masterData) {
                            displayResult("Matched", "");
                        } else {
                            displayResult(scannedText, "❌");
                        }
                        break;
                    case "treasureHunt":
                        displayResult(scannedText, scannedText === masterData ? "⭕️" : "No match");
                        break;
                    default:
                        break;
                }
            }
        }

        function displayResult(data, symbol) {
            document.getElementById('result').textContent = `${data} ${symbol}`;
        }
    </script>

</body>
</html>
